"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Route_1 = __importDefault(require("../Route"));
var AwsSamRouter_1 = __importDefault(require("../../classes/AwsSamRouter"));
var userService = {
    getUser: jest.fn(),
    getUsers: jest.fn(),
    createUser: jest.fn(),
    deleteUser: jest.fn(),
    getClient: jest.fn(),
    getClients: jest.fn(),
    createClient: jest.fn(),
    deleteClient: jest.fn(),
};
var UserController = /** @class */ (function () {
    function UserController() {
    }
    UserController.prototype.getUser = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                userService.getUser();
                return [2 /*return*/, { statusCode: 200, body: 'ok' }];
            });
        });
    };
    UserController.prototype.getUsers = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                userService.getUsers();
                return [2 /*return*/, { statusCode: 200, body: 'ok' }];
            });
        });
    };
    UserController.prototype.createUser = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                userService.createUser();
                return [2 /*return*/, { statusCode: 200, body: 'ok' }];
            });
        });
    };
    UserController.prototype.deleteUser = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                userService.deleteUser();
                return [2 /*return*/, { statusCode: 200, body: 'ok' }];
            });
        });
    };
    __decorate([
        (0, Route_1.default)('get', '/user/{id}/'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], UserController.prototype, "getUser", null);
    __decorate([
        (0, Route_1.default)('get', '/user/'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], UserController.prototype, "getUsers", null);
    __decorate([
        (0, Route_1.default)('post', '/user/'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], UserController.prototype, "createUser", null);
    __decorate([
        (0, Route_1.default)('delete', '/user/{id}/'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], UserController.prototype, "deleteUser", null);
    return UserController;
}());
var ClientsController = /** @class */ (function () {
    function ClientsController() {
    }
    ClientsController.prototype.getClient = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                userService.getClient();
                return [2 /*return*/, { statusCode: 200, body: 'ok' }];
            });
        });
    };
    ClientsController.prototype.getClients = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                userService.getClients();
                return [2 /*return*/, { statusCode: 200, body: 'ok' }];
            });
        });
    };
    ClientsController.prototype.createClient = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                userService.createClient();
                return [2 /*return*/, { statusCode: 200, body: 'ok' }];
            });
        });
    };
    ClientsController.prototype.deleteClient = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                userService.deleteClient();
                return [2 /*return*/, { statusCode: 200, body: 'ok' }];
            });
        });
    };
    __decorate([
        (0, Route_1.default)('get', '/user/clients/{id}/'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], ClientsController.prototype, "getClient", null);
    __decorate([
        (0, Route_1.default)('get', '/user/clients/'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], ClientsController.prototype, "getClients", null);
    __decorate([
        (0, Route_1.default)('post', '/user/clients/'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], ClientsController.prototype, "createClient", null);
    __decorate([
        (0, Route_1.default)('delete', '/user/clients/{id}'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], ClientsController.prototype, "deleteClient", null);
    return ClientsController;
}());
var router = new AwsSamRouter_1.default();
var userController = new UserController();
var clientsController = new ClientsController();
router.use(clientsController.getClient);
router.use(clientsController.getClients);
router.use(clientsController.createClient);
router.use(clientsController.deleteClient);
router.use(userController.getUser);
router.use(userController.getUsers);
router.use(userController.createUser);
router.use(userController.deleteUser);
var handler = router.expose();
function assert(serviceFn, _a) {
    var _this = this;
    var resource = _a.resource, httpMethod = _a.httpMethod;
    it("should route to ".concat(httpMethod, " ").concat(resource), function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, handler({ resource: resource, httpMethod: httpMethod }, {})];
                case 1:
                    result = _a.sent();
                    expect(result.body).toEqual('ok');
                    expect(serviceFn).toHaveBeenCalled();
                    return [2 /*return*/];
            }
        });
    }); });
}
describe('Route decorator + AWSProxyRouter', function () {
    beforeEach(function () {
        jest.resetAllMocks();
    });
    assert(userService.getUser, { resource: '/user/{id}/', httpMethod: 'GET' });
    assert(userService.getUsers, { resource: '/user/', httpMethod: 'GET' });
    assert(userService.createUser, { resource: '/user/', httpMethod: 'POST' });
    assert(userService.deleteUser, { resource: '/user/{id}/', httpMethod: 'DELETE' });
    assert(userService.getClient, { resource: '/user/clients/{id}/', httpMethod: 'GET' });
    assert(userService.getClients, { resource: '/user/clients/', httpMethod: 'GET' });
    assert(userService.createClient, { resource: '/user/clients/', httpMethod: 'POST' });
    assert(userService.deleteClient, { resource: '/user/clients/{id}', httpMethod: 'DELETE' });
});
